/***************************************************************************
                          tdeconfirmmanualenterdlg.h
                             -------------------
    begin                : Mon Apr  9 2007
    copyright            : (C) 2007 by Thomas Baumgart
    email                : Thomas Baumgart <ipwizard@users.sourceforge.net>
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TDECONFIRMMANUALENTERDLG_H
#define TDECONFIRMMANUALENTERDLG_H

// ----------------------------------------------------------------------------
// TQt Includes

// ----------------------------------------------------------------------------
// TDE Includes

// ----------------------------------------------------------------------------
// Project Includes

// ----------------------------------------------------------------------------
// Project Includes

#include <kmymoney/mymoneytransaction.h>
#include "../dialogs/tdeconfirmmanualenterdlgdecl.h"

class KConfirmManualEnterDlg : public KConfirmManualEnterDlgDecl
{
  TQ_OBJECT
  
public:
  KConfirmManualEnterDlg(const MyMoneySchedule& schedule, TQWidget* parent = 0, const char* name = 0);

  typedef enum {
    UseOriginal = 0,
    ModifyOnce,
    ModifyAlways
  } Action;

  /**
    * setup the dialog for the difference between the original transaction
    * @a to and the transaction to be entered @a tn.
    */
  void loadTransactions(const MyMoneyTransaction& to, const MyMoneyTransaction& tn);

  /**
    * Returns information about what to do with the transaction
    */
  Action action(void) const;
};

#endif // TDECONFIRMMANUALENTERDLG_H
